program BTCpuCountDemo;

 {* * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * *
  * BTCpuCount (CPU Counting Util-Unit, incl. Hyper-Threading-Technology)   *
  *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*
  * Copyright (c) 2002 - 2010 by Martin Offenwanger (www.dsplayer.de)  	    *
  *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*
  * Mozilla Public License Version 1.1:                                     *
  *- - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - - -*
  * The contents of this file are used with permission, subject to the      *
  * Mozilla Public License Version 1.1 (the "License"); you may             *
  * not use this file except in compliance with the License. You may        *
  * obtain a copy of the License at                                         *
  * http://www.mozilla.org/MPL/MPL-1.1.html                                 *
  *                                                                         *
  * Software distributed under the License is distributed on an             *
  * "AS IS" basis, WITHOUT WARRANTY OF ANY KIND, either express or          *
  * implied. See the License for the specific language governing            *
  * rights and limitations under the License.                               *
  * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * * }
{
@author(Martin Offenwanger: mo@danfort.dk, coder@dsplayer.de)
@created(Nov 24, 2010)
@lastmod(Nov 20, 2010)
}

{$APPTYPE CONSOLE}

uses
  SysUtils,
  BTCpuCount in 'BTCpuCount.pas';

var
  LogicalNum: Byte = 0;
  PhysicalNum: Byte = 0;
  HTStatusFlag: Byte = 0;

begin

  Writeln('---------------------------------------------------------------------');
  Writeln('BTCpuCount (CPU Counting Utility , incl. Hyper-Threading-Technology)');
  Writeln('Copyright (c) 2002 - 2010 by Martin Offenwanger (www.dsplayer.de)');
  Writeln('---------------------------------------------------------------------');
  Writeln('');

  HTStatusFlag := BTGetCPUCount(LogicalNum, PhysicalNum);
  case HTStatusFlag of
    HT_NOT_CAPABLE:
      Writeln('Hyper-threading technology not capable');
    HT_DISABLED:
      Writeln('Hyper-threading technology disabled');
    HT_ENABLED:
      Writeln('Hyper-threading technology enabled');
    HT_SUPPORTED_NOT_ENABLED:
      Writeln('Hyper-threading technology capable but not enabled');
    HT_CANNOT_DETECT:
      Writeln('Hyper-threading technology cannot be detected');
  end;

  Writeln('Number of logical processors per physical processors: ' +
    IntToStr(LogicalNum));

  if PhysicalNum <> Byte(-1) then
    Writeln('Number of physical processors: ' +
      IntToStr(PhysicalNum))
  else begin
 		Writeln('Can''t determine number of physical processors');
		Writeln('Make sure to enable ALL processors');
  end;

  Readln;
end.
